#include "sort.h"
#include <stdio.h>

bool isSorted(int size, int tab[size], bool (*comp)(int, int)){

  for( int i = 1; i<size;i++){
      if(comp(tab[i-1],tab[i])){
        //printf("not sorted\n");
        return false;
      }
  }
  //printf("sorted !\n");
  return true;
}

void random_tab(int size,int tab[size],int min,int max) {
   assert(max > min);
   for (int i=0;i<size;i++) {
      tab[i] = min+rand()%(max-min);
   }
}

bool isGreater(int a, int b) { return a > b; }

bool isSmaller(int a, int b) { return a < b; }

void swap(int *a, int *b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

void print_array(int *arr, int size) {
  for (int i = 0; i < size; i++) {
    printf("%d ", arr[i]);
  }
  printf("\n");
}


void sort(int *sorted, const int *const orig, int nitems, bool (*comp)(int, int)) {

  // copy
  for (int i = 0; i < nitems; i++) {
    sorted[i] = orig[i];
  }

  for (int j = nitems; j > 1; j--) {

    for (int i = 0; i < j; i++) {
      if (comp(sorted[i], sorted[i + 1])) {
        swap(&sorted[i], &sorted[i + 1]);
      }
    }
  }

}