#include "sort.h"
#include <stdio.h>

bool isSorted(int nitems, int sorted[nitems], bool (*comp)(int, int)){

  for( int i = 1; i<nitems;i++){
      if(comp(sorted[i-1],sorted[i])){
        printf("not sorted\n");
        return false;
      }
  }
  printf("sorted !\n");
  return true;
}


void random_tab(int nitems,int sorted[nitems],int min,int max) {
   assert(max > min);
   for (int i=0;i<nitems;i++) {
      sorted[i] = min+rand()%(max-min);
   }
}

bool isGreater(int a, int b) { return a > b; }

bool isSmaller(int a, int b) { return a < b; }

void swap(int *a, int *b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

void print_array(int *arr, int nitems) {
  for (int i = 0; i < nitems; i++) {
    printf("%d ", arr[i]);
  }
  printf("\n");
}


void sort(int *sorted, const int *const orig, int nitems, bool (*comp)(int, int)) {

  // copy
  for (int i = 0; i < nitems; i++) {
    sorted[i] = orig[i];
  }

    
   // recherche dans le sortedleau de l'indice de la plus petite valeur
   int ind_min = 0; 
   for (int k=1;k<nitems;k++) {
      if (sorted[k] < sorted[ind_min]) {
         ind_min = k;
      }
   }

   // échange de la 1ère valeur avec la plus petite du sortedleau
   int tmp = sorted[0];
   sorted[0] = sorted[ind_min];
   sorted[ind_min] = tmp;
  
   // tri par sélection
   for (int i=0;i<nitems-1;i++) {
      ind_min = i; 
      for (int k=i+1;k<nitems;k++) {
         if (sorted[k] < sorted[ind_min]) {
            ind_min = k;
         }
      } 
      tmp = sorted[i];
      sorted[i] = sorted[ind_min];
      sorted[ind_min] = tmp;
   }

}
