#include "sort.h"

bool isSorted(int size, int tab[size], bool (*comp)(int, int)){

  for( int i = 1; i<size;i++){
      if(comp(tab[i-1],tab[i])){
        //printf("not sorted\n");
        return false;
      }
  }
  //printf("sorted !\n");
  return true;
}

void random_tab(int size,int tab[size],int min,int max) {
   assert(max > min);
   for (int i=0;i<size;i++) {
      tab[i] = min+rand()%(max-min);
   }
}

bool isGreater(int a, int b) { return a > b; }

bool isSmaller(int a, int b) { return a < b; }

void swap(int *a, int *b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

void print_array(int *arr, int size) {
  for (int i = 0; i < size; i++) {
    printf("%d ", arr[i]);
  }
  printf("\n");
}


// Partition du tableau <array> autour d'une valeur pivot:
int partition(int size, int array[size], int first, int last,bool (*comp)(int, int)) {
  int pivot = array[last];
  int i = first;
  int j = last-1;
  while (true) {

    while (comp(array[i],pivot)){
      i++;
    } //array[i]<pivot

   while (!comp(array[j],pivot)){
      j--;
    }  //array[j]>pivot

    if (i >= j) {
      break;
    }
    //  échanger cases <i> et <j> du tableau <array>
    swap(&array[i], &array[j]);
  }
  // échanger cases <i> et <last> du tableau <array>
  swap(&array[i], &array[last]);
  return i;
}

// Tri rapide récursif
void quicksort(int size, int array[size], int first, int last,bool (*comp)(int, int)) {
  if (first < last) {
    int midpoint = partition(size, array, first, last,comp);
    if (first < midpoint - 1) {
      quicksort(size, array, first, midpoint - 1,comp);
    }
    if (midpoint + 1 < last) {
      quicksort(size, array, midpoint + 1, last,comp);
    }
  }
}

void sort(int *sorted, const int *const orig, int nitems, bool (*comp)(int, int)) {

   // copy
  for (int i = 0; i < nitems; i++) {
    sorted[i] = orig[i];
  }
  quicksort(nitems, sorted, 0, nitems-1,comp);


}
