#include "stack.h"
#include <stdlib.h>


void stack_init(stack *stack, int size) {
  stack->data = malloc(sizeof(void*)* size);
  stack->top = -1;
  stack->capacity = size;
}

bool is_empty(stack stack) { return stack.top == -1; }

bool is_full(stack stack) { return stack.capacity - 1 == stack.top; }

void *peek(stack stack) {
  if (is_empty(stack)) {
    return NULL;
  }
  return stack.data[stack.top];
}

int stack_count(stack stack) { return stack.top + 1; }

void stack_destroy(stack *stack) {
  free(stack->data);
  stack->top = -1;
  stack->capacity = -1;
}

void push(stack *stack, void *item) {
  if (!is_full(*stack)) {
    stack->top++;
    stack->data[stack->top] = item;
  }
}

void *pop(stack *stack) {
  void *tmp;
  tmp = stack->data[stack->top];
  stack->top--;
  return tmp;
}