#include "circ.h"
#include <stdio.h>
#include <stdlib.h>

// typedef struct element {
//   void *content;
//   struct element *next;
// } element;

// Crée une nouvelle liste vide. Renvoie simplement un pointeurNULL
element *list_create() { return NULL; }

// true si la liste est vide
bool list_empty(element *head) { return head == NULL; }

// Renvoie le nombre d’éléments de la listeunsigned
int list_count(element *head) {
  if (list_empty(head)) {
    return 0;
  }

  int count = 1;
  element *crt = head;

  while (crt->next != head) {
    crt = crt->next;
    count++;
  }
  printf("\n%d elements\n", count);
  return count;
}

// Déplace le pointeur head sur l’élément suivant. Retourne la nouvelle têtede
// liste
element *list_move(element *head) {
  head = head->next;
  return head;
}

element *move(element *head, int i) {
  while (i > 0) {
    head = list_move(head);
    i--;
  }
  return head;
}

// Insert un élément après le pointeur head. Retourne le pointeur sur l’élé-ment
// inséré
element *list_insert_after(element *head, void *data) {

  if (list_empty(head)) {
    head = malloc(sizeof(element));
    head->content = data;
    head->next = head;
    return head;
  }

  element *tmp = malloc(sizeof(element));
  tmp->content = data;
  tmp->next = head->next;
  head->next = tmp;
  return tmp;
}

// Insert un élément avant le pointeur head. Retourne le pointeur sur l’élé-ment
// inséré
element *list_insert_before(element *head, void *data) {

  if (list_empty(head)) {
    head = malloc(sizeof(element));
    head->content = data;
    head->next = head;
    return head;
  }

  element *crt = head;
  while (crt->next != head) {
    crt = crt->next;
  }
  element *tmp = malloc(sizeof(element));
  tmp->content = data;

  tmp->next = head;
  crt->next = tmp;

  return tmp;
}

// Recherche un élément dans la liste. Retourne un pointeur sur le 1erélément
// trouvé ouNULLsi l’élément est absent
element *list_search(element *head, void *data,
                     int (*compare)(void *, void *)) {
  element *crt = head;

  while (compare(crt->content, data)) {
    crt = crt->next;
    if (crt->next == head) {
      return NULL;
    }
  }
  return crt;
}

// Supprime un élément de la liste sans libérer l’élément pointé. Renvoie
// unpointeur sur le 1er élément trouvé à supprimer et l’enlève de la liste,
// ouNULLsi l’élément est absent
element *list_remove(element *head, void *data,
                     int (*compare)(void *, void *)) {

  element *crt = head;

  while (compare(crt->next->content, data)) {
    crt = crt->next;
    if (crt->next == head) {
      return NULL;
    }
  }

  element *removed = crt->next;
  crt->next = crt->next->next;

  return removed;
}

// Supprime toute la liste en libérant chaque élément
void list_free(element *head, void (*data_free)(void *)) {

  element *tmp = head->next;
  while (tmp != head) {
    head->next = tmp->next;
    data_free(tmp);
    tmp = head->next;
  }
  data_free(head);
}

// Appel d’une fonction de traitement quelconque sur chaque élément de laliste
void list_process(element *head, void *(*action)(void *)) {
  element *crt = head->next;
  while (crt != head) {
    crt = action(crt);
    crt = crt->next;
  }
  crt = action(head);
}

void *print_int(void *x) {
  printf("%d ", *(int *)((element *)x)->content);
  return x;
}

void free_simple(void *ptr) { free(ptr); }

void custom_free(void *ptr) {
  free(((element *)ptr)->content);
  free(ptr);
}

int cmp_int(void *a, void *b) {

  if (*(int *)a > *(int *)b) {
    return 1;
  } else if (*(int *)a < *(int *)b) {
    return -1;
  } else {
    return 0;
  }
}

void joseph(element *head, int n, int k) {

  head = list_create();

  for (int i = 0; i < n; i++) {
    int *x = malloc(sizeof(int));
    *x = i + 1;
    head = list_insert_after(head, x);
  }

  for (int i = 0; i < n; i++) {
    head = move(head, k - 1);
    element *tmp = remove_crt(head);
    printf("%d\n", *(int *)tmp->content);
    custom_free(tmp);
  }
}

element *remove_crt(element *head) {

  element *crt = head->next;
  while (crt != head) {
    crt = crt->next;
  }

  element *removed = crt->next;
  crt->next = crt->next->next;

  return removed;
}
