#ifndef _circ_H_
#define _circ_H_

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct element {
  void *content;
  struct element *next;
} element;

// Crée une nouvelle liste vide. Renvoie simplement un pointeurNULL
element* list_create();

// este si la liste est vide
bool list_empty(element* head);

// Renvoie le nombre d’éléments de la listeunsigned 
int list_count(element* head);

// Déplace le pointeur head sur l’élément suivant. Retourne la nouvelle têtede liste
element* list_move(element* head);

element* move(element* head,int i);

// Insert un élément après le pointeur head. Retourne le pointeur sur l’élé-ment inséré
element* list_insert_after(element* head, void* data);

// Insert un élément avant le pointeur head. Retourne le pointeur sur l’élé-ment inséré
element* list_insert_before(element* head, void* data);

// Recherche un élément dans la liste. Retourne un pointeur sur le 1erélément trouvé ouNULLsi l’élément est absent
element* list_search(element* head,void* data,int (*compare)(void*, void*));

// Supprime un élément de la liste sans libérer l’élément pointé. Renvoie unpointeur sur le 1er élément trouvé à supprimer et l’enlève de la liste, ouNULLsi l’élément est absent
element* list_remove(element* head, void* data,int (*compare)(void*, void*));

element *remove_crt(element *head);

// Supprime toute la liste en libérant chaque élément
void list_free(element* head, void (*data_free)(void*));

// Appel d’une fonction de traitement quelconque sur chaque élément de laliste
void list_process(element* head, void* (*action)(void*));

void joseph(element* head, int n,int k);





#endif
