#ifndef _PGM_H_
#define _PGM_H_

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"

typedef enum _pgm_error {
    success, failure
} pgm_error;


typedef struct _pgm {
    int max;
    matrix pixels;
} pgm;

pgm_error pmg_read_from_file(pgm *p, char *filename);

pgm_error pmg_write_to_file(pgm *p, char *filename);

pgm_error pmg_negative(pgm *neg, const pgm *const orig);


pgm_error pmg_symmetry_hori(pgm *sym, const pgm *const orig);

pgm_error pmg_symmetry_vert(pgm *sym, const pgm *const orig);

pgm_error pmg_symmetry_cent(pgm *sym, const pgm *const orig);


pgm_error pmg_photomaton(pgm *photomaton, const pgm *const orig);

pgm_error pmg_crop(pgm *crop, const pgm *const orig, int x0, int x1, int y0, int y1);

pgm_error pmg_conv(pgm *conv, const pgm *const orig, const matrix *const kernel);



#endif
