#ifndef _QUADTREE_H_
#define _QUADTREE_H_

#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>
#include "matrix.h"
#include "PGM.h"

#define CHILDREN 4

typedef struct _node
{
    double ave;    
    double ave_sq; 
    struct _node *child[CHILDREN];
} node;

node *tree_create(int depth);

void tree_destroy(node *tree);

void print(node *tree, int decal, char *sep);

void matrix2tree(matrix *mat, node *tree);

void tree2matrix(node *tree, matrix *mat);

void symetry(node *tree,int bit);

void compress(node *tree, double seuil);

node *tree_from_file(char *filename);

void tree_to_file(node *tree, char *filename);

void compress_with_rate(node *tree, double seuil);

#endif