#include "queue.h"
#include <stdio.h>
#include <stdlib.h>

// typedef struct _element {
//     T pixel;
//     struct _element *next;
// } element;

// typedef struct _queue {
//    element* firstIn; //head
//    element* lastIn; //debut
// } queue;

pixel pixel_init(int x,int y){
    pixel p;
    p.x=x;
    p.y=y;
    return p;
}

queue createQ(){
    queue Q;
    Q.firstIn=NULL;
    Q.lastIn=NULL;
    return Q;
}

void destroyQ(queue *Q){

    while(Q->firstIn!=NULL){
        element* tmp=Q->firstIn->next;
        free(Q->firstIn);
        Q->firstIn=tmp;
    }
}

void insertQ(queue *Q, T value){
    element *tmp = malloc(sizeof(element));
    tmp->pixel=value;
    tmp->next=NULL;
    if(isQueueEmpty(*Q)){
        Q->firstIn=tmp;
    }else{
        Q->lastIn->next=tmp;
    }
    Q->lastIn= tmp;
}

T extractFirst(queue *Q) {
    T val=Q->firstIn->pixel;
    element* oldFirst=Q->firstIn;
    Q->firstIn=Q->firstIn->next; //next !
    free(oldFirst);
    return val;
}

T getFirst(queue Q){
    return Q.firstIn->pixel;
}

bool isQueueEmpty(queue Q){
    return Q.firstIn==NULL;
}

int queueCount(queue Q){
    int count=0;
    
    while (Q.firstIn!=NULL) {
        count++;
        Q.firstIn=Q.firstIn->next;
    }
    return count;
}

void displayQ(queue Q){
    while (Q.firstIn!=NULL) {
       printf("[%d,%d] ",Q.firstIn->pixel.x,Q.firstIn->pixel.y);
        Q.firstIn=Q.firstIn->next;
    }
    printf("\n");
}





// int main() {

//   queue Q = createQ();

//   for (int i = 0; i < 10; i++) {
//     insertQ(&Q, i);
//   }
//     displayQ(Q);
//     extractFirst(&Q);
//     displayQ(Q);
//     destroyQ(&Q);

    
//   return EXIT_SUCCESS;
// }