#include "snake.h"
#include <stdint.h>

// typedef enum _dir{LEFT,RIGHT,TOP,DOWN} dir;

// typedef struct _snake{
//     queue body;
//     dir mvt;
// } snake;

void snake_init(snake *snk, int height, int width) {

  snk->body = createQ(); // snake's head = lastIn
  snk->dir = RIGHT;
  snk->currentFood=0;

  pixel p = pixel_init(width / 2, height / 2);

  for (int i = 0; i < 3; i++) {
    insertQ(&(snk->body), p);
    p.x++;
  }
}

void step(snake *snk, struct gfx_context_t *ctxt) {

  pixel next = snk->body.lastIn->pixel;

  switch (snk->dir) {
  case RIGHT:
    next.x++;
    break;

  case LEFT:
    next.x--;
    break;

  case UP:
    next.y--;
    break;

  case DOWN:
    next.y++;
    break;
  }

  insertQ(&(snk->body), next);//new head
  //draw
  


    switch(gfx_getpixel(ctxt, next.x, next.y)){
        case wall:
        
          printf("head in the wall !\n");
          exit(EXIT_SUCCESS);
        break;

        case food:
          printf("miam\n");
          snk->currentFood--;
        break;

        case empty:
        gfx_putpixel(ctxt, snk->body.firstIn->pixel.x,snk->body.firstIn->pixel.y, empty);
        extractFirst(&(snk->body)); //moves
        break;

        case body:
          printf("canibalism !\n");
          exit(EXIT_SUCCESS);
        break;
    }
    gfx_putpixel(ctxt, snk->body.lastIn->pixel.x,snk->body.lastIn->pixel.y, body);
}

void input_handler(snake *snk, SDL_Keycode key){

  switch(key){
    case SDLK_RIGHT:
      snk->dir=RIGHT;
    break;
    case SDLK_LEFT:
    snk->dir=LEFT; 
    break;
    case SDLK_UP:
    snk->dir=UP;
    break;
    case SDLK_DOWN:
    snk->dir=DOWN;
    break;
  }
}

void generateFood(struct gfx_context_t *ctxt,int width, int height){

  while(true){
    int x=rand()%width-2;
    int y=rand()%height-2;

    if(gfx_getpixel(ctxt, x, y)==empty){
      gfx_putpixel(ctxt, x, y,food);
      break;
    }

  }
}